//#include <stdio.h>

typedef unsigned int        UINT, *PUINT;

void mc_gost_encdec(int, int*, unsigned int*, int);

unsigned long keys[] = {
        0x1eadbeaf,
        0x2eadbeaf,
        0x3eadbeaf,
        0x4eadbeaf,
        0x5eadbeaf,
        0x6eadbeaf,
        0x7eadbeaf,
        0x8eadbeaf
};
/* //       
unsigned long long sblock[] = {
    0x35F7C1B6E08D29A4,
    0x95701832AFD6C4BE,
    0xB9067CFE243AD185,
    0x352BC64EF9801AD7,
    0x2B30E9A48DF517B6,
    0xEFC95863D1270AB4,
    0xC2867EA095F314BD,
    0xC8B6E3294A750DF1
};
*/

unsigned long sblock[] = {
    0xE08D29A4, 0x35F7C1B6,
    0xAFD6C4BE, 0x95701832,
    0x243AD185, 0xB9067CFE,
    0xF9801AD7, 0x352BC64E,
    0x8DF517B6, 0x2B30E9A4,
    0xD1270AB4, 0xEFC95863,
    0x95F314BD, 0xC2867EA0,
    0x4A750DF1, 0xC8B6E329
};


int idx;
int key = 0;

unsigned int aa;
unsigned int bb;


unsigned int ROL(unsigned int a, int n)
{
    unsigned int t1, t2;
    n = n % (sizeof(a)*8); //  n
    t1 = a << n; //     n ,   
    t2 = a >> (sizeof(a)*8 - n); //     
    return t1 | t2; //     
}

int key1_24(int i)
{
    char *p = (char *)keys;
    i = (i & 7) << 2; // i=0..23
//    printf("idx=%d i=%d\n", idx, i);
    key = *((int*)(p + i));
    return key;
}

int key25_32(int i)
{
    char *p = (char *)keys;
    i = (i & 7) << 2;
    key = *((int*)(p + 7*4 - i));
    return key;
}

int enc_epilogue()
{
    int i, j, k, xor;

        idx++;
        i = idx - 24;
        k = idx - 32;
        j = i & 0x80000000;
        xor = (k & 0x80000000) ^ j;
        if ((j | xor) == 0) {
           return 0;
        }
        if (j != 0)
           key1_24(idx);
        if (xor != 0)
           key25_32(idx);
        return 1;
}

int dec_epilogue()
{
    int i, j, k, xor;

        idx--;
        i = idx - 24;
        k = idx - 32;
        j = i & 0x80000000;
        xor = (k & 0x80000000) ^ j;
        if (idx < 0) {
           return 0;
        }
        if (j != 0) //   (idx - 25)
           key1_24(idx);
        if (xor != 0) // 1 xor (0  1)
           key25_32(idx);
        return 1;
}


unsigned int slr64(unsigned int al, unsigned int ah, int n)
{
    unsigned int t1, t2;
    
    if ((n - 32)>=0)
    {
     return ah >> (n - 32); 
    }
    
    t1 = ah << (32 - n);
    t2 = al >> n;
    return t1 | t2; //     
}


void gost_round()
{
        int i;
        unsigned int old_bb;
        unsigned int fAiKi = 0;

        int axk = key ^ aa;

        for (i=0; i<8; i++) {
#if DBG_SB
            unsigned int axk_4bit = (axk >> (i*4)) & 0xf;
            unsigned int sb_idx = axk_4bit << 2;
            unsigned int sb_val = sblock[i] >> sb_idx;
            unsigned int f_val = (sb_val & 0xf) << (i*4);
            fAiKi |= f_val;
//            printf("\t%d: 4bit=%x idx=%02x sb=%08x f=%08x\n", i, axk_4bit, sb_idx, sb_val, f_val);
#else

            fAiKi |= ((slr64(sblock[i*2], sblock[i*2+1], (((axk >> (i*4)) & 0xf) << 2)) & 0xf) << (i*4));

          //  fAiKi |= ((sblock[i] >> (((axk >> (i*4)) & 0xf) << 2)) & 0xf) << (i*4);

#endif
        }
        old_bb = bb;
        bb = aa;
        aa = old_bb ^ ROL(fAiKi, 11);
 //       printf("aa=%08x bb=%08x key=%08x axk=%08x fAiKi=%08x ROL=%08x\n", aa, bb, key, axk, fAiKi, ROL(fAiKi, 11));
}



int main()
{
    int i;
    unsigned int old;
    unsigned int buf[] = { 0x12345678, 0x9abcdef1 };
    
    unsigned int old_aa;    
    unsigned int old_bb;

    // 
    PUINT aaa;
    
    aaa = (PUINT) 0x1E000;
    *aaa = 0xAAAAAAAA; 
    aaa = (PUINT) 0x1E100;
    *aaa = 0xAAAAAAAA;

    aa = buf[0];
    bb = buf[1];


 //   printf("--------(%d)-------\n", idx);
 

/* //
    old_aa = aa;
    old_bb = bb;
    
   // 
   for (i = 0; i < 5; i++)
   {
    idx = 0;
    key1_24(0);
    do {
        gost_round();
    } while (enc_epilogue());

  //  printf("\t\taa=%08x bb=%08x\n--------(%d)-------\n", aa, bb, idx);
    old = aa;
    aa = bb;
    bb = old;
   }

   // 
   for (i = 0; i < 5; i++)
   {
    idx = 31;
    key25_32(31);
    do {
        gost_round();
    } while (dec_epilogue());
    old = aa;
    aa = bb;
    bb = old;
   }
*/


/* //  ASM
   old_aa = aa;
   old_bb = bb;

   // .  ASM 
   for (i = 0; i < 4; i++)
   {
    mc_gost_encdec(0, (int *)keys, (unsigned int *)buf, 1);
    old = buf[0];
    buf[0] = buf[1];
    buf[1] = old;
   }
   mc_gost_encdec(0, (int *)keys, (unsigned int *)buf, 1);

   // .  ASM 
   for (i = 0; i < 4; i++)
   {
    mc_gost_encdec(1, (int *)keys, (unsigned int *)buf, 1);
    old = buf[0];
    buf[0] = buf[1];
    buf[1] = old;
   }
   mc_gost_encdec(1, (int *)keys, (unsigned int *)buf, 1);
   
   aa = buf[0];
   bb = buf[1];
*/


 //  ASM
   old_aa = aa;
   old_bb = bb;

   mc_gost_encdec(0, (int *)keys, (unsigned int *)buf, 1);

   mc_gost_encdec(1, (int *)keys, (unsigned int *)buf, 1);

   aa = buf[0];
   bb = buf[1];


/* //  ASM

   mc_gost_encdec(0, (int *)keys, (unsigned int *)buf, 1);

   old_aa = buf[0];
   old_bb = buf[1];

   buf[0] = aa;
   buf[1] = bb;

   gost_encdec(1, (int *)keys, (unsigned int *)buf, 1);

   aa = buf[0];
   bb = buf[1];
*/


//  !
      aaa = (PUINT) (0x1E004);
      *aaa = aa;            
      
      aaa = (PUINT) (0x1E008);
      *aaa = old_aa;

      aaa = (PUINT) (0x1E104);
      *aaa = bb;            
      
      aaa = (PUINT) (0x1E108);
      *aaa = old_bb;

     if (aa != old_aa)
     {
      aaa = (PUINT) 0x1E000;
      *aaa = 0xFFFFFFFF;
     } 

     if (bb != old_bb)
     {
      aaa = (PUINT) 0x1E100;
      *aaa = 0xFFFFFFFF;
     } 

    return 0;
}
